import { transformFileSync } from "@babel/core";
import * as path from "path";

import babelPlugin from "./index";

describe("@cuarun/babel", () => {
  test("proper transforms a single job call", () => {
    const result = transformFileSync(
      path.join(__dirname, "fixtures/single-call.ts"),
      {
        presets: ["@babel/preset-typescript"],
        plugins: [[babelPlugin]],
        babelrc: false,
        configFile: false,
      }
    );
    expect(result?.code).toMatchSnapshot();
  });
  test("proper transforms a multiple different jobs call", () => {
    const result = transformFileSync(
      path.join(__dirname, "fixtures/multiple-calls.ts"),
      {
        presets: ["@babel/preset-typescript"],
        plugins: [[babelPlugin]],
        babelrc: false,
        configFile: false,
      }
    );
    expect(result?.code).toMatchSnapshot();
  });
  test("proper transforms when '@cua.run/client' was already imported", () => {
    const result = transformFileSync(
      path.join(__dirname, "fixtures/client-already-imported.ts"),
      {
        presets: ["@babel/preset-typescript"],
        plugins: [[babelPlugin]],
        babelrc: false,
        configFile: false,
      }
    );
    expect(result?.code).toMatchSnapshot();
  });
});
